## boot-floppies 2.2.26

=== Makefile ===
# Top-level Makefile for boot-floppies
#   see README* for information

# @@ Marcel FIXME: resc*.bin target for i386 make both resc*.bin and root*.bin:
#                  update scripts and clean make rules

# configurable variables reside in the config file
-include config

top_dir		:= $(CURDIR)

tmpdir		:= $(shell . ./common.sh; echo $$tmpdir)

# where to look for .deb files (local updates, archive base & admin dirs)
pathcmd		= ls -1ft $(CURDIR)/updates/P $(local_dir)/P $(archive)/base/P $(archive)/admin/P $(archive)/devel/P $(archive)/utils/P 2>/dev/null | head -1

kbd_package	:= $(shell $(pathcmd:P=console-data*.deb))

export GZIP	:= -9

# documentation rules live in documentation/Makefile*
-include documentation/Makefile.docs

#---------------------------------------------------------------------------

ifneq ($(strip $(findstring $(LINGUA),$(LATIN1))),)
	export FONT=lat1u-16.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(LATIN2))),)
	export FONT=iso02g.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(LATIN3))),)
	export FONT=iso03g.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(KOI8-R))),)
	export FONT=koi8-r.psf
endif

ifeq ($(FONT), iso02g.psf)
	export SFONT=iso02g.psf
endif
ifeq ($(FONT), iso03g.psf)
	export SFONT=iso03.f16
endif
ifeq ($(FONT), koi8-r.psf)
	export SFONT=koi8-r
endif

# shell needs to be set to base for the release target, at least
SHELL = bash

# [ED] avoid direct compilation of C programs from the utilities subdir
# (see the root.bin dependencies).  BTW utils target does the right job.
.SUFFIXES:

all::	build

null:
	: Null target for testing Makefile with "make -p null"

#---------------------------------------------------------------------------

ifneq ($(EXT),)
# if second call from build target (make EXT=...)
# build alternate rescue/drivers disks
    kver:=$(altkver)
    altkver:=
endif

# Only need major and minor numbers, not patchlevel.
KERNEL_VERSION_CODE := $(shell echo ${kver} | awk -FS=. '{v = ($$1 * 65536 + $$2 * 256); print v;}')

# find the newest kernel image of each type
kernel	:= $(shell $(pathcmd:P=kernel-image-$(kver)_*.deb))
# sanity fallback for kernel
ifeq ($(strip $(kernel)),)
kernel	:= kernel-image-$(kver)_$(kver)-1.deb
endif

ifndef pcmcia_kver
pcmcia_kver		:= $(kver)
endif

pcmcia_package		:= $(shell $(pathcmd:P=pcmcia-modules-$(pcmcia_kver)_*.deb))

#### i386 part
kerneli386_compact := $(shell $(pathcmd:P=kernel-image-$(kver)-compact_*.deb))
pcmciai386_compact := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-compact_*.deb))
kerneli386_udma66 := $(shell $(pathcmd:P=kernel-image-$(kver)-ide_*.deb))
pcmciai386_udma66 := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-ide_*.deb))
kerneli386_idepci := $(shell $(pathcmd:P=kernel-image-$(kver)-idepci_*.deb))
pcmciai386_idepci := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-idepci_*.deb))

#### alpha part

# Please look in `config' and for instructions on where to get the
# various bits and bobs needed on Alpha, and how to set them up

# The list of subarchitectures to build for
alpha_arches		:= generic alcor avanti book1 cabriolet \
	eb164 eb64p eb66 eb66p jensen lx164 miata-s miata mikasa \
	noname noritake-p noritake p2k pc164 rawhide ruffian rx164 \
	sable-g sable sx164 xl xlt takara nautilus
alpha_milo_arches	:= alcor avanti book1 cabriolet eb164 eb64p \
	eb66 eb66p lx164 miata-s miata mikasa noname pc164 p2k \
	ruffian sx164 xl xlt takara
alpha_apb_arches	:= nautilus

# This gets the generic one
kernelalpha	        := $(shell $(pathcmd:P=kernel-image-$(kver)-generic*_alpha.deb))

ifeq ($(alpha_reduced_rescue_set),YES)
# We only build rescue disks for a subset of the available
# architectures (basically generic, and the ones where the generic
# kernel doesn't work)
alpha_rescue_arches     := generic jensen nautilus
else
alpha_rescue_arches	:= $(alpha_arches)
endif

# What we're actually going to build
alpha_rescue_targets	:= $(alpha_rescue_arches:%=resc1440_%.bin)
alpha_drivers_targets	:= $(alpha_rescue_arches:%=drv14alpha_%-1.bin)
ifeq ($(build_milo_disks),YES)
alpha_milo_targets	:= $(alpha_milo_arches:%=milo_%.bin)
endif

#### m68k part
# The list of subarchitectures to build for
kernelatari	:= $(shell $(pathcmd:P=kernel-image-$(kver)-atari*.deb))
kernelamiga	:= $(shell $(pathcmd:P=kernel-image-$(kver)-amiga*.deb))
kernelmac	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mac*.deb))
kernelbvme6000	:= $(shell $(pathcmd:P=kernel-image-$(kver)-bvme6000*.deb))
kernelmvme16x	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mvme16x*.deb))
kernelmvme147	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mvme147*.deb))

#### powerpc part
kernelapus	:= $(shell $(pathcmd:P=kernel-image-$(apuskver)-apus*.deb))
kernelchrp	:= $(shell $(pathcmd:P=kernel-image-$(kver)-chrp*.deb))
kernelmbx	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mbx*.deb))
kernelpmac	:= $(shell $(pathcmd:P=kernel-image-$(kver)-pmac*.deb))
kernelprep	:= $(shell $(pathcmd:P=kernel-image-$(kver)-prep*.deb))
kernelsource	:= $(shell $(pathcmd:P=kernel-source-$(kver)*.deb))
kernelpatch	:= $(shell $(pathcmd:P=kernel-patch-$(kver)-powerpc*.deb))

#### arm part
kernel-riscpc	:= $(shell $(pathcmd:P=kernel-image-$(kver)-riscpc*.deb))
kernel-netwinder := $(shell $(pathcmd:P=kernel-image-$(kver)-netwinder*.deb))
kernel-shark	:= $(shell $(pathcmd:P=kernel-image-$(kver)-shark*.deb))

#### sparc part
# Sparc dist contains 3 kernels:
#  -sun4cdm (for non-sun4u)
#  -sun4dm-pci
#  -sun4u (ultrasparc)
ifeq ($(architecture),sparc)
  kernel64	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4u_*.deb))
  kernel	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4cdm_*.deb))
  kernelPCI	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4dm-pci_*.deb))
endif


#---------------------------------------------------------------------------
# Consistency checks
#---------------------------------------------------------------------------

# Additional dependancy checks:
ifeq ($(architecture), i386)
  depends_checks := dosfstools syslinux zlib-bin
  tools_checks := rawrite2.zip lodlin16.zip
endif
ifeq ($(architecture), sparc)
  depends_checks := sparc-utils
endif
ifeq ($(architecture), alpha)
  depends_checks := aboot
endif
ifeq ($(architecture), powerpc)
  depends_checks := snarf dosfstools hfsutils
  CHECKFS := check_msdos
endif
ifeq ($(architecture), m68k)
  depends_checks := dosfstools hfsutils pmac-fdisk-cross
endif
ifeq ($(USE_LANGUAGE_CHOOSER), true)
  depends_checks += python-xml libpng2-dev libpopt-dev slang1-dev gconv-modules python-dev
endif

# check_minux disabled
check: localfiles check_mirror check_loop check_kernel check_depends check_tools $(CHECKFS)
	@echo "check successful"

# Use this to check if your kernel has support for the minix filesystem
check_minix:
	@grep minix /proc/filesystems 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/fs/minix.o || \
		( echo minix filesystem support needed; exit 1 )

# Use this to check if your kernel has support for the msdos filesystem
check_msdos:
	@grep msdos /proc/filesystems 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/fs/msdos.o || \
		( echo msdos filesystem support needed; exit 1 )

# Use this to check if your kernel has support for the loop device
check_loop:
	@grep loop /proc/devices 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/block/loop.o || \
		( echo loop device support needed ; exit 1 )

# Use this to check if your local mirror has all the required packages
check_mirror: check_mirror.sh
	./check_mirror.sh $(archive)

# Are our depends satisfied?  (i.e., for people using CVS)
check_depends:
	@echo checking boot-floppies dependancies
	@perl -e \
	  '$$_=`sed -n s/^Depends://Ip debian/control`."$(depends_checks)"; \
	   $$/="\n\n"; y/,/ /; s/\(.*?\)//g; @M{split()}=""; while (<>) { \
	     /^Status: \S+ \S+ installed$$/ms or next; \
	     delete $$M{$$1} if /^Package: (\S+)/ms; \
	     delete @M{split(/ *, */,$$1)} if /^Provides: (.+?)$$/ms; \
	   } foreach my $$m (keys %M) { print "  didn'\''t find $$m\n" } \
	   exit 1 if %M' /var/lib/dpkg/status

check_tools:
ifneq ($(tools_checks), )
	@echo "checking stuff in $(tools_dir)"
	@for t in $(tools_checks); do \
	  [ -f $(tools_dir)/$$t ] || { echo "  didn't find $$t"; e=1; }; \
	done; exit $$e
endif

# Use this to see if you have the proper kernels available
MSG=standard

check_kernel:
	@echo checking packages needed for kernel images
ifeq ($(architecture), i386)
	@[ -f "$(kernel)" ] || \
		( echo $(MSG) kernel \($(kver)\) is not available ; exit 1 )
	@[ -f "$(pcmcia_package)" ] || \
		( echo $(MSG) PCMCIA modules \($(pcmcia_kver)\) are not available ; exit 1 )
	@[ -f "$(kerneli386_compact)" ] || \
		( echo compact kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_compact)" ] || \
		( echo compact flavor PCMCIA modules are not available ; exit 1 )
	@[ -f "$(kerneli386_udma66)" ] || \
		( echo udma66 kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_udma66)" ] || \
		( echo udma66 flavor PCMCIA modules are not available ; exit 1 )
	@[ -f "$(kerneli386_idepci)" ] || \
		( echo idepci kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_idepci)" ] || \
		( echo idepci flavor PCMCIA modules are not available ; exit 1 )
else
ifeq ($(architecture), m68k)
	@[ -f "$(kernelatari)" ] || \
		( echo atari kernel is not available ; exit 1 )
	@[ -f "$(kernelamiga)" ] || \
		( echo amiga kernel is not available ; exit 1 )
	@[ -f "$(kernelmac)" ] || \
		( echo mac kernel is not available ; exit 1 )
	@[ -f "$(kernelbvme6000)" ] || \
		( echo bvme6000 kernel is not available ; exit 1 )
	@[ -f "$(kernelmvme16x)" ] || \
		( echo mvme16x kernel is not available ; exit 1 )
	@[ -f "$(kernelmvme147)" ] || \
		( echo mvme147 kernel is not available ; exit 1 )
else
ifeq ($(architecture), powerpc)
	@[ -f "$(kernelapus)" ] || \
		( echo apus kernel is not available ; exit 1 )
	@[ -f "$(kernelchrp)" ] || \
		( echo chrp kernel is not available ; exit 1 )
	@[ -f "$(kernelpmac)" ] || \
		( echo pmac kernel is not available ; exit 1 )
	@[ -f "$(kernelprep)" ] || \
		( echo prep kernel is not available ; exit 1 )
	@[ -f "$(kernelsource)" ] || \
		( echo kernel source is not available ; exit 1 )
	@[ -f "$(kernelpatch)" ] || \
		( echo kernel patch is not available ; exit 1 )
	@[ -f "$(pcmcia_package)" ] || \
		( echo $(MSG) PCMCIA modules are not available ; exit 1 )
else
ifeq ($(architecture), sparc)
	@[ -f "$(kernel)" ] || \
		( echo $(MSG) sun4cdm kernel is not available ; exit 1 )
	@[ -f "$(kernel64)" ] || \
		( echo $(MSG) sun4u kernel is not available ; exit 1 )
	@[ -f "$(kernelPCI)" ] || \
		( echo $(MSG) sun4dm-pci kernel is not available ; exit 1 )
else
ifeq ($(architecture), alpha)
	@[ -f "$(kernelalpha)" ] || \
		( echo $(MSG) kernel is not available ; exit 1 )
else
ifeq ($(architecture), arm)
	@[ -f "$(kernel-riscpc)" ] || \
		( echo $(MSG) riscpc kernel is not available ; exit 1 )
	@[ -f "$(kernel-netwinder)" ] || \
		( echo $(MSG) netwinder kernel is not available ; exit 1 )
#	@[ -f "$(kernel-shark)" ] || \
#		( echo $(MSG) shark kernel is not available ; exit 1 )
else
	@echo unsupported architecture: $(architecture); false
endif
endif
endif
endif
endif
endif
ifneq ($(altkver),)
	$(MAKE) check_kernel EXT=-$(altkver) MSG=alternative
endif

#---------------------------------------------------------------------------
# Don't edit below this line

ifeq ($(architecture), sparc)
silo_pkg		:= $(shell $(pathcmd:P=silo_*.deb))
arch_rootdisk_deps	:= silo1440k-sun4cdm.gz silo1440k-sun4u.gz
arch_rescue_deps	:= silo1440k-sun4cdm.gz silo1440k-sun4u.gz
endif

localfiles:: updates
	cd $(incoming) && \
	  find . \( -name '*_all.deb' -o -name '*_$(architecture).deb' \) -exec cp {} $(CURDIR)/updates/ \;
	cd $(local_dir) && \
	  find . -name '*.deb' -exec cp {} $(CURDIR)/updates/ \;

# dependency for the files that have to be copied
updates::
	[ -d updates ] || mkdir -p updates

# helper target to mirror base locally
mirror:
	[ -d $(archive) ] || mkdir -p $(archive)
	cd $(archive) && $(top_dir)/mirror_base.sh $(architecture)	\

=== documentation/Makefile ===
# Makefile for documentation
# 
# See README-authors for more information.

.SUFFIXES:

-include ../config
-include Makefile.docs

OFFICIALWEBBUILD := $(official_debian)

# whether documentation should be installed in subdirs;
# see install-langs target
INSTALLSTYLE	?= subdir

# fdisk documentation to include (varies per platform)
FDISK_DOCS := $(shell grep -s fdisk \
		../scripts/rootdisk/SMALL_BASE_LIST_$(architecture) | \
		sed -e 's/^.*\/\(.*\)/\1.txt/' 2>/dev/null)

# set extension of source/dest files based on LINGUA
ifeq ($(LINGUA),C)
SRCEXT		:=
DESTEXT		:= .en
DESTDIRADD	:=
else
SRCEXT		:= .$(LINGUA)
DESTEXT		:= .$(LINGUA)
DESTDIRADD	:= $(LINGUA)
endif

# programs for creating output
DEBIANDOC2HTML	:= debiandoc2html -d debiandoc.decl -l $(LINGUA) -c
DEBIANDOC2PS	:= debiandoc2ps -d debiandoc.decl -l $(LINGUA)
DEBIANDOC2TEXT	:= debiandoc2text -d debiandoc.decl -l $(LINGUA)
DEBIANDOC2LATEX	:= debiandoc2latex -d debiandoc.decl -l $(LINGUA)

# detailed sgml validation
NSGMLS		:= nsgmls -ges -wall /usr/lib/sgml/declaration/debiandoc.decl

# maximum times we're willing to run TeX to get cross-references right, if you subtract by 3
MAX_TEX_RECURSION	:= 6

# documents to build
TARGETDOCS := index.en.html			\
	      install$(DESTEXT).txt		\
	      install$(SRCEXT).html/install$(DESTEXT).html \
	      $(FDISK_DOCS)

# some languages don't have dselect-beginner -- that's ok
ifneq ($(LINGUA),fi)
TARGETDOCS += dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
	      dselect-beginner$(DESTEXT).txt
endif

# you might want to remove this if it is failing for you
#   ja and ru documents are currently not converted into .pdf correctly 
ifneq ($(LINGUA),ja)
ifneq ($(LINGUA),ru)
TARGETDOCS	+= install$(DESTEXT).pdf
endif
endif

EXTRAFILES	:= officiallogo-nd-50.jpg openlogo-nd-50.jpg

# just an unreasonable default
DESTDIR		:= /tmp

install_file	:= install -m 644 -p
makedir		:= mkdir -m 0755
ifdef OFFICIALWEBBUILD
install_file	:= install -m 2664 -p
makedir		:= mkdir -m 2775
endif

# how the date is represented in the document
DATEFORM_$(LINGUA) := %d %B, %Y		# default date representation
DATEFORM_fi	:= %-d.%-m.%Y
DATEFORM_hr	:= %-d. %-m. %Y.	# hr is an exception from the above rule

DEB_VERSION	:= $(shell cd .. && LC_ALL=C dpkg-parsechangelog |	\
			grep '^Version: ' | sed 's/^Version: *//')
DATE		:= $(shell cd .. && date --date="`dpkg-parsechangelog |	\
			grep '^Date: ' | sed 's/^Date: *//'`" 		\
			'+$(strip $(DATEFORM_$(LINGUA)))')

# derived entity files
DERIVED_ENTS	:= messages.ent dynamic.ent
# this for is used for dependencies
ENT_DEPENDS	:= defaults.ent messages.ent dynamic.ent

define checklingua
  if [ -z "$(LINGUA)" ]; then \
  echo LINGUA variable is not set -- see documentation/README-authors; \
  exit 1; \
  fi
endef

# actual rules start here
# (note: default rule is the default one from Makefile.docs, not this one)
.PHONY:	all
all:	supplemental_makefile $(TARGETDOCS) $(EXTRATARGETDOCS)

.PHONY: lint
lint:	$(ENT_DEPENDS)
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Installation Manual, language $(LINGUA):"
	$(NSGMLS) install$(SRCEXT).sgml
#	@echo "Checking for deprecated entity references:"
#	nsgmls -oentity /usr/lib/sgml/declaration/debiandoc.decl \
#	  install$(SRCEXT).sgml 2>/dev/null | sed -e '/^IMSG/!d' -e 's/^I/   /'
	# po2sgml:epilogue sets up some those references
endif
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for dselect Documentation for Beginners, language $(LINGUA):"
	$(NSGMLS) dselect-beginner$(SRCEXT).sgml
endif

.PHONY:	validate
validate:	$(ENT_DEPENDS)
	@set -ex; for i in *.sgml; do $(NSGMLS) $$i; done

.PHONY:	supplemental_makefile
supplemental_makefile:
	@$(checklingua)
	@[ ! -f $(LINGUA)/Makefile ] || $(MAKE) -C $(LINGUA)

# generate the nice index page.
# FIXME: is m4 really the right way to do this?
ifneq "$(wildcard index$(DESTEXT).html.m4)" ""
index$(DESTEXT).html: index$(DESTEXT).html.m4; m4 \
 --define=ARCHITECTURE=${architecture} \
 --define=OFFICIAL=${OFFICIALWEBBUILD} \
    $< > $@
else
.PHONY: index$(DESTEXT).html index.en.html
endif

# this will probably only work if your name is "Adam Di Carlo"
.PHONY: ChangeLog
ChangeLog:
	cvs2cl.pl --tags --branches --revisions --utc	\
	  --usermap $$HOME/debian/boot-floppies/CVSROOT/users

# generic rules for all the languages and output formats -- Installation Manual.
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
install$(SRCEXT).html/install$(DESTEXT).html:	install$(SRCEXT).sgml	\
						$(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t install $<

install$(DESTEXT).txt:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

install$(DESTEXT).ps:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) -O $< > $@

install$(DESTEXT).tex:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: install$(SRCEXT).html/install$(DESTEXT).html install$(DESTEXT).txt \
        install$(DESTEXT).ps install$(DESTEXT).tex install$(DESTEXT).pdf
endif

# generic rule for all the PDFs
%.pdf:	%.tex
#	 note that I have seen bi-stable .aux files, thus we check two levels deep
	-cp -pf prior.aux pprior.aux 2>/dev/null
	-cp -pf $(basename $<).aux prior.aux 2>/dev/null
#	 fail if we don't have pdflatex correctly installed
	kpsewhich pdflatex.fmt >/dev/null
#	 due to a bug in debiandoc2latex2e output, this might fail
	-pdflatex '\nonstopmode\input{$<}' >/dev/null # see $(@:.pdf=.log) for details
	@set -e								;\
	if ! cmp $(basename $<).aux prior.aux 2>/dev/null &&		\
	   ! cmp $(basename $<).aux pprior.aux 2>/dev/null; then	\
		if expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION) >/dev/null;\
		then							\
		   echo "remaking $@ (take $(MAKELEVEL))"		;\
		   rm -f $@						;\
		   $(MAKE) $@						;\
		else							\
		   echo "E: $@ needs remaking, but we have reached max. level, $(MAX_TEX_RECURSION)" ;\
		fi							\
	fi
	rm -f prior.aux pprior.aux

# generic rules for all the languages and output formats -- dselect Documentation for Beginners
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html:		\
		dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t dselect-beginner $<

dselect-beginner$(DESTEXT).txt:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

dselect-beginner$(DESTEXT).ps:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) $<

dselect-beginner$(DESTEXT).tex:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
        dselect-beginner$(DESTEXT).txt dselect-beginner$(DESTEXT).ps \
        dselect-beginner$(DESTEXT).tex dselect-beginner$(DESTEXT).pdf
endif

# these rules generate text files out of *fdisk programs' manpages
cfdisk.txt:
	if [ -f "$(utillinux)" ]; then					 \
	  dpkg --fsys-tarfile $(utillinux) |				 \
		tar -xOf - '*/man8/cfdisk.8.gz' | zcat > tmp		;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

fdisk.txt:
	if [ -f "$(utillinux)" ]; then					 \
	  dpkg --fsys-tarfile $(utillinux) |				 \
		tar -xOf - '*/man8/fdisk.8.gz' | zcat > tmp		;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

atari-fdisk.txt:
	if [ -f "$(atarifdisk)" ]; then					 \
	  dpkg --fsys-tarfile $(atarifdisk) |				 \
		tar -xOf - '*/man8/atari-fdisk.8.gz' | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

amiga-fdisk.txt:
	if [ -f "$(amigafdisk)" ]; then					 \
	  dpkg --fsys-tarfile $(amigafdisk) |				 \
		tar -xOf - '*/man8/amiga-fdisk.8.gz' | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

mac-fdisk.txt:
	if [ -f "$(macfdisk)" ]; then					 \
	  dpkg --fsys-tarfile $(macfdisk) |				 \
		tar -xOf - '*/man8/mac-fdisk.8.gz'  | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

pmac-fdisk.txt:
	if [ -f "$(pmacfdiskcross)" ]; then				 \
	  dpkg --fsys-tarfile $(pmacfdiskcross) |			 \
		tar -xOf - '*/man8/pmac-fdisk.8.gz' | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	fi
	[ -f $@ ] || echo '** man page not found ** ' > $@

.PHONY: install
install:
	set -e								;\
	for lang in $(buildable-langs); do				 \
	    echo "installing $$lang"					;\
	    $(MAKE) LINGUA=$$lang install-lang				;\
	done
ifdef OFFICIALWEBBUILD
#	setting our nice content-negotiation symlinks
	set -e								;\
	for file in `find arch/$(architecture) -name '*.en.*'`; do	 \
	    ln -sf `basename $$file` `echo $$file | sed -e 's/\.en//'`	;\
	done
endif

.PHONY:	install-lang
install-lang:
	[ -d $(DESTDIR) ] || $(makedir) -p $(DESTDIR)
ifneq ($(INSTALLSTYLE),subdir)
#	install all langs files into one directory
	$(install_file) $(TARGETDOCS) $(EXTRAFILES)			 \
		$(wildcard dselect-beginner$(SRCEXT).html/*		 \
		install$(SRCEXT).html/*) $(DESTDIR)
else		# subdirectory install, to make things easier to find
	for doc in $(TARGETDOCS) $(EXTRAFILES)				 \
		$(wildcard dselect-beginner$(SRCEXT).html/* 		 \
		install$(SRCEXT).html/*); do				 \
	    $(makedir) -p $(DESTDIR)/$(DESTDIRADD)				;\
	    $(install_file) $$doc $(DESTDIR)/$(DESTDIRADD)		;\
	done
#	make index.html symlink to index.??.html for all subdirs
	set -e								;\
	for file in `find $(DESTDIR) -name 'index.??.html'`; do		 \
	    ln -sf `basename $$file`					 \
		   `echo $$file | sed -e 's/\...\.html/.html/'`		;\
	done
endif

.PHONY:	clean
clean:
	rm -rf arch
	rm -f $(DERIVED_ENTS) dynamic_*.ent messages*.ent
	rm -rf $(TARGETDOCS) install*.html dselect-beginner*.html
	rm -f *fdisk.txt dselect-beginner*.txt install*.txt
	rm -rf release-notes*.html release-notes*.txt
	rm -rf upgrade-*
	rm -f *.log *.aux *.bak *.out *.sasp* *.toc *.tex *.dvi *.pdf *.ps
	rm -f relnotes.tar.bz2
	set -e ; for dir in `find . -type d -mindepth 1 -maxdepth 1`; do \
	    [ ! -f $$dir/Makefile ] || $(MAKE) -C "$$dir" $@		;\
	done

.PHONY:	distclean
distclean: clean
	rm -f *~ *.orig \#*

##
## upload docs to http://www.debian.org/releases/...
##
# this will only work if you're in debwww group on localhost and on master
mirror-to-master:
	@[ -d arch ] || { echo "Run make (uni-)doc-web first!"; exit 1; }
	chgrp -R debwww arch
	find arch -type f | xargs chmod 0664
	find arch -type d | xargs chmod g+sw
	rsync -rltDpgvz --rsh ssh arch/		\
	  www-master.debian.org:/org/www.debian.org/debian.org/releases/$(debname)/


# generate entities which are dynamically defined by the settings of this
# build run, generally set in the top-level config file
dynamic_$(LINGUA)_$(architecture).ent: ../debian/changelog
ifeq "$(architecture)" ""
	@echo architecture variable is not set -- see documentation/README-authors
	exit 1
endif
ifeq "$(findstring $(architecture), $(arches))" ""
	@echo architecture variable is set to something strange, edit ../config
	exit 1
endif
	: > $@			# clear the file
	echo "<!entity docversion       \"$(DEB_VERSION)\">" >> $@
	echo "<!entity docdate          \"$(DATE)\">" >> $@
	echo "<!entity language         \"$(LINGUA)\">" >> $@
	echo "<!entity langext          \"$(DESTEXT)\">" >> $@
	echo "<!entity release          \"$(debianversion)\">" >> $@
	echo "<!entity releasename      \"$(debname)\">" >> $@
	echo "<!entity kernelversion    \"$(kver)\">" >> $@
	echo "<!entity altkernelversion \"$(altkver)\">" >> $@
	echo "<!entity architecture     \"$(architecture)\">" >> $@
	echo "<!entity % $(architecture) \"INCLUDE\">" >> $@
	echo "<!entity % lang-$(LINGUA) \"INCLUDE\">" >> $@
	set -e; for i in $(FDISK_DOCS); do			    \
		echo "<!entity % $$i    \"INCLUDE\">" >> $@;\
	done
ifdef OFFICIALWEBBUILD
	echo "<!entity % official-web-build \"INCLUDE\">" >> $@
	echo "<!entity path-to-top-level \"\">" >> $@
else

=== powerpc-specials/Makefile ===
# Makefile for PowerPC install documentation and BootX fetching
#
# Docs are english version and TXT for now
# but could be html, ps or pdf

-include ../config

ifeq ($(LINGUA),C)
   LINGUA := en
endif

all:
	sgml2txt install-chrp.$(LINGUA).sgml
	sgml2txt install-pmac.$(LINGUA).sgml
	sgml2txt install-prep.$(LINGUA).sgml
	sgml2txt install-apus.$(LINGUA).sgml

	# Fetch BootX and bootvars tools - these should be in tools/   
	snarf http://penguinppc.org/~benh/BootX_1.2.2.sit
	snarf http://http.us.debian.org/debian/dists/stable/main/disks-powerpc/current/powermac/bootvars1.3b.sit.hqx

clean:
	rm -f install-*.txt BootX* bootvars* yaboot* ybin*

=== utilities/Makefile ===

include ../config

CC			:= gcc
CFLAGS			:= -O2 -fomit-frame-pointer
LDFLAGS			:= -s
arch			:= $(shell dpkg --print-architecture)

SUBDIRS	:= libfdisk dbootstrap busybox writemaps

ifneq ($(arch),m68k)
  SUBDIRS	+= lowmemrd
endif

ifeq ($(USE_LANGUAGE_CHOOSER),true)
# bogl enabled
SUBDIRS	+= bogl
endif

SPLIT_OBJECTS	:= floppy_split.o

all:		floppy_split $(SUBDIRS)

.PHONY:		$(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@ KVER=${KVER} KERNEL_VERSION_CODE=${KERNEL_VERSION_CODE}

clean:
	rm -f *.o *.bak po.utf rn.utf all.utf
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done

distclean: clean
	rm -f floppy_split
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i distclean; done

floppy_split: $(SPLIT_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(SPLIT_OBJECTS)

# dependancies
$(SPLIT_OBJECTS):	floppy_split.h

=== documentation/ru/Makefile ===
orig_dir=../en
diff_args=-ub

chapters= administrivia dbootstrap hardware inst-methods partitioning post-install preparing rescue-boot tech-info welcome appendix

all:    # do nothing

help:
	@echo Please specify what you want to do
	@echo Possible actions are:
	@echo   diff            -- check all registered documents
	@echo   diff-\<document\> -- check whether the original of the specified document has changed
	@echo
	@echo Please note, that \<document\> should not contain .sgml extension

diff: $(addprefix diff-,$(chapters))

diff-%: %.sgml
# @echo $<: $(shell fgrep "english version" $< | sed -e 's/^  english version: unknown//; s/^  english version: \(.*\)/-r\1/')
	-cvs -z6 diff $(diff_args) $(shell fgrep "english version" $< | sed -e 's/^  english version: unknown//; s/^  english version: \(.*\)/-r\1/') ../en/$<

clean:

=== powerpc-specials/coffboot/Makefile ===
CC      = $(CROSS_COMPILE)gcc
HOST_CC = gcc
LD      = $(CROSS_COMPILE)ld
CFLAGS  = -O -fno-builtin
OBJCOPY = $(CROSS_COMPILE)objcopy
OBJCOPY_ARGS = -O aixcoff-rs6000 -R .stab -R .stabstr -R .comment --add-section=image=vmlinux.gz
LD_ARGS = -e _start -T ld.script -Ttext 500000 -Tdata 510000 -Bstatic
GZ = gzip -9

OBJS = crt0.o ctype.o errno.o start.o main.o misc.o string.o vsprintf.o zlib.o

coffboot: $(OBJS) ld.script
	$(LD) -o coffboot $(LD_ARGS) $(OBJS)

hack-coff: hack-coff.c
	$(HOST_CC) $(CFLAGS) -o hack-coff hack-coff.c

vmlinux.gz: ../../linuxpmac
	$(OBJCOPY) -S -O binary ../../linuxpmac vmlinux
	gzip -9fv vmlinux

ramdisk.image.gz: ../../rootpmac.bin
	cp $< $@

../../rescue-pmac.coff: coffboot hack-coff vmlinux.gz ramdisk.image.gz
	$(OBJCOPY) $(OBJCOPY_ARGS) --add-section=initrd=ramdisk.image.gz coffboot $@
	./hack-coff $@

clean:
	rm -f coffboot hack-coff vmlinux.gz ramdisk.image.gz *.o *~

=== utilities/bogl/Makefile ===
LIBS = -lc
LIB = libbogl.a

CFLAGS = -O2 -D_GNU_SOURCE

-include ../../config

CFLAGS += -I../dbootstrap
CFLAGS += -DARCH=$(architecture) -DARCHNAME='"$(architecture)"' 
CFLAGS += -DKVER='"$(KVER)"' 
CFLAGS += -DLINGUA='"$(LINGUA)"' -DINCLINGUA='"messages/lang_$(LINGUA).h"'
CFLAGS += -Wall -g

xml_langs=$(shell fgrep generated_languages= ../dbootstrap/langs/Makefile  | sed -e 's/generated_languages=//')
xml_files=$(addprefix ../dbootstrap/langs/,$(xml_langs))

LIBOBJECTS = $(LIBBOGLOBJECTS) $(LIBBOMLOBJECTS) $(LIBBOWLOBJECTS)	\
	$(LIBRSRCOBJECTS)
LIBBOGLOBJECTS = bogl.o bogl-font.o
LIBBOMLOBJECTS = arrow.o boml.o
LIBBOWLOBJECTS = bowl.o symbol.o
LIBRSRCOBJECTS = helvB10.o helvB12.o helvR10.o timBI18.o tux75.o

SOURCES_DEP = arrow.c bdftobogl.c bogl-cfb.c bogl-cfb.h bogl-cfb8.c	\
bogl-cfb8.h bogl-font.c bogl-font.h bogl-pcfb.c bogl-pcfb.h		\
bogl-tcfb.c bogl-tcfb.h bogl-test.c bogl.c bogl.h boglP.h boml.c	\
boml.h bowl-boxes.c bowl.c bowl.h pngtobogl.c

ifeq (,)
	CFLAGS += -DBOGL_CFB_FB=1
	LIBBOGLOBJECTS += bogl-cfb.o bogl-pcfb.o bogl-tcfb.o
endif

ifeq ($(architecture), i386)
	CFLAGS += -DBOGL_VGA16_FB=1
	LIBBOGLOBJECTS += bogl-vga16.o
	SOURCES_DEP += bogl-vga16.c bogl-vga16.h
endif

OBJECTS = $(LIBOBJECTS) bowl-boxes.o

GENERATED = helvB10.c helvB12.c helvR10.c timBI18.c tux75.c

all:    depend $(LIB) bterm bdftobogl libutf8_plug.so unifont-reduced.bgf

unifont-reduced.bgf: bdftobogl unifont-reduced.bdf
	./bdftobogl -b unifont-reduced.bdf > unifont-reduced.bgf

unifont-reduced.bdf: ../bf-utf/unifont.bdf ../all.utf libutf8_plug.so reduce-font
	LD_PRELOAD=./libutf8_plug.so LC_CTYPE=C.UTF-8 ./reduce-font $< < ../all.utf > $@

../all.utf: ../po.utf ../rn.utf $(xml_files)
	cat $^ > $@

../po.utf:
	$(MAKE) -C ../dbootstrap/po all-po-utf
	cat ../dbootstrap/po/utf/*.po > $@

../rn.utf:
	$(MAKE) RN_TARGET_DIR=. -C ../../scripts/rootdisk/messages install-utf
	cat ../../scripts/rootdisk/messages/release_notes.* > $@

$(LIB): $(OBJECTS)
	rm -f $(LIB)
	ar rcs $(LIB) $(OBJECTS)

bogl-test: $(LIB) bogl-test.c tux75.o
	$(CC) $(CFLAGS) -o bogl-test bogl-test.c tux75.o $(LIB)

bowl-boxes: $(LIB)
	$(CC) -DSTANDALONE_TEST $(CFLAGS) bowl-boxes.c $(LIBOBJECTS) -o bowl-boxes

bterm: $(LIB) bterm.o bogl-term.o bogl-bgf.o
	$(CC) $+ $(LIB) -o bterm

bdftobogl: $(LIBBOGLOBJECTS)
%.c: %.bdf bdftobogl
	./bdftobogl $< > $@

pngtobogl: pngtobogl.o
	$(CC) $(CFLAGS) -o pngtobogl pngtobogl.o -lgd -lpng -lm
%.c: %.png pngtobogl
	./pngtobogl $< > $@

libutf8_plug.so:
	$(MAKE) -C ../bf-utf/libutf8
	cp -f ../bf-utf/libutf8/libutf8_plug.so $@

depend: $(SOURCES_DEP)
	$(CPP) $(CFLAGS) -M $(SOURCES_DEP) > .depend

clean: 
	rm -rf reduce-font libutf8_plug.so bterm bdftobogl pngtobogl *.o $(GENERATED) *-test lang.h tmp.*.c bowl-boxes $(LIB) unifont-reduced.bgf unifont-reduced.bdf

distclean: clean
	rm -f $(LIB) .depend *~ .nfs*

force:

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== utilities/busybox/Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2000 Erik Andersen <andersee@debian.org>
# Copyright (C) 2000 Karl M. Hegbloom <karlheg@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

PROG      := busybox
VERSION   := 0.43
BUILDTIME := $(shell TZ=UTC date --utc "+%Y.%m.%d-%H:%M%z")

# Set the following to `true' to make a debuggable build.
# Leave this set to `false' for production use.
# eg: `make DODEBUG=true tests'
DODEBUG = false

# If you want a static binary, turn this on.  I can't think
# of many situations where anybody would ever want it static, 
# but...
DOSTATIC = false

# This will choke on a non-debian system
ARCH =`uname -m | sed -e 's/i.86/i386/' | sed -e 's/sparc.*/sparc/'`

CC = gcc

GCCMAJVERSION = $(shell $(CC) --version | sed -n "s/^[^0-9]*\([0-9]\)\.\([0-9].*\)[\.].*/\1/p")
GCCMINVERSION = $(shell $(CC) --version | sed -n "s/^[^0-9]*\([0-9]\)\.\([0-9].*\)[\.].*/\2/p")


GCCSUPPORTSOPTSIZE = $(shell			\
if ( test $(GCCMAJVERSION) -eq 2 ) ; then	\
    if ( test $(GCCMINVERSION) -ge 66 ) ; then	\
	echo "true";				\
    else					\
	echo "false";				\
    fi;						\
else						\
    if ( test $(GCCMAJVERSION) -gt 2 ) ; then	\
	echo "true";				\
    else					\
	echo "false";				\
    fi;						\
fi; )


ifeq ($(GCCSUPPORTSOPTSIZE), true)
    OPTIMIZATION = -Os
else
    OPTIMIZATION = -O2
endif

# Allow alternative stripping tools to be used...
ifndef $(STRIPTOOL)
    STRIPTOOL = strip
endif


# -D_GNU_SOURCE is needed because environ is used in init.c
ifeq ($(DODEBUG),true)
    CPPFLAGS += -D_GNU_SOURCE
    CFLAGS   += -Wall -g
    LDFLAGS  =
    STRIP    =
else
    CPPFLAGS += -D_GNU_SOURCE
    CFLAGS   += -Wall $(OPTIMIZATION) -fomit-frame-pointer -fno-builtin
    LDFLAGS   = -s
    STRIP     = $(STRIPTOOL) --remove-section=.note --remove-section=.comment $(PROG)
    #Only staticly link when _not_ debugging 
    ifeq ($(DOSTATIC),true)
	LDFLAGS += --static
    endif
endif

ifndef $(PREFIX)
    PREFIX = `pwd`/_install
endif

LIBRARIES =
OBJECTS   = $(shell ./busybox.sh) busybox.o messages.o utility.o

CPPFLAGS     += -DBB_VER='"$(VERSION)"'
CPPFLAGS     += -DBB_BT='"$(BUILDTIME)"'
ifdef BB_INIT_SCRIPT
    CPPFLAGS += -DINIT_SCRIPT='"$(BB_INIT_SCRIPT)"'
endif

all: busybox busybox.links
.PHONY: all

busybox: $(OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBRARIES)
	$(STRIP)

busybox.links: busybox.def.h
	- ./busybox.mkll | sort >$@

regexp.o nfsmount.o: %.o: %.h
$(OBJECTS): %.o: busybox.def.h internal.h  %.c

.PHONY: test tests
test tests:
	cd tests && $(MAKE) all

.PHONY: clean
clean:
	- cd tests && $(MAKE) clean
	- rm -f busybox.links *~ *.o core
	- rm -rf _install

.PHONY: distclean
distclean: clean
	- rm -f busybox
	- cd tests && $(MAKE) distclean

.PHONY: install
install: busybox busybox.links
	./install.sh $(PREFIX)

.PHONY: dist release
dist release: distclean
	cd ..;					\
	rm -rf busybox-$(VERSION);		\
	cp -a busybox busybox-$(VERSION);	\
						\
	find busybox-$(VERSION)/ -type d	\
				 -name CVS	\
				 -print		\
		| xargs rm -rf;			\
						\
	find busybox-$(VERSION)/ -type f	\
				 -name .cvsignore \
				 -print		\
		| xargs rm -f;			\
						\
	tar -cvzf busybox-$(VERSION).tar.gz busybox-$(VERSION)/;

=== utilities/dbootstrap/Makefile ===
#
#  Makefile for `dbootstrap', the Debian GNU/Linux/Hurd installer.
#
# Copyright (c) 2000 Karl M. Hegbloom <karlheg@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#

# Call make with 'no_pointerize=1' to temporarily prevent translation
# message files from being updated by changes to C sources, to speed
# up compilation during development.

PROG   = dbootstrap
PROG_G = dbootstrap_g
PROG_LC = dbootstrap-lc

ifeq ($(USE_LANGUAGE_CHOOSER), true)
all all_potato : $(PROG) $(PROG_LC)
else
all all_potato : $(PROG)
endif

all_woody      : $(PROG) $(PROG_G)

TESTS = interactive_shell			\
	boxes					\
	release_notes				\
	main_menu				\
	kbdconfig				\
	choose_medium				\
	floppy_merge				\
	pcmcia					\
	netconfig				\
	tzconfig				\
	partition_config			\
	select_not_mounted			\
	bootconfig				\
	reboot_system				\
	net-fetch

_TESTS   := $(addsuffix _test,   $(TESTS))
_TESTS_G := $(addsuffix _g_test, $(TESTS))

tests   : $(_TESTS)
tests_g : $(_TESTS_G)

null:
	@: Use the null target with "make -p" for debugging Makefile.

.PHONY : all all_potato all_woody test test_g

# Set DEBUG to `true' to make a debuggable build.  Leave it `false'
# for production use.  It will be automaticly set to `true' by a
# target local override when you build the *_test targets.
#
# eg: `make DEBUG=true dbootstrap'.
#
DEBUG  = false
# DEBUG  = true

EFENCE = false
ifeq ($(EFENCE),true)
LEFENCE = -lefence
endif

# To compile in the language chooser, set this to `true'.
#
USE_LANGUAGE_CHOOSER ?= false

# Set this to the language with which you want to run the *_test
# targets.  eg: `make TESTLANG=de dbootstrap_test'
#
TESTLANG = C

CC = gcc

-include ../../config

GCCMAJVERSION=$(shell $(CC) --version | sed -n "s/^\([^\.]*\).*/\1/p" )
GCCMINVERSION=$(shell $(CC) --version | sed -n "s/^[^\.]*\.\([^\.]*\)[\.].*/\1/p" )

GCCSUPPORTSOPTSIZE := $(shell			\
if ( test $(GCCMAJVERSION) -eq 2 ) ; then	\
    if ( test $(GCCMINVERSION) -ge 66 ) ; then	\
	echo "true";				\
    else					\
	echo "false";				\
    fi;						\
else						\
    if ( test $(GCCMAJVERSION) -gt 2 ) ; then	\
	echo "true";				\
    else					\
	echo "false";				\
    fi;						\
fi; )


ifeq ($(GCCSUPPORTSOPTSIZE), true)
    OPTIMIZATION := -Os
else
    OPTIMIZATION := -O2
endif

ifeq ($(DEBUG),true)
    CPPFLAGS	= -D_GNU_SOURCE
    CFLAGS	= -Wall -g3 -pipe $(EXTRA_CFLAGS)
    LDFLAGS	= 
    STRIP	= :
else
    CPPFLAGS	= -D_GNU_SOURCE
    CFLAGS	= -Wall $(OPTIMIZATION) -fomit-frame-pointer -fno-builtin -pipe
    LDFLAGS	= -s
    STRIP	= strip --remove-section=.note --remove-section=.comment
endif

_LIBFDISK = ../libfdisk/libfdisk.a

_LIBBOGL  = ../bogl/libbogl.a

${_LIBFDISK} ${_LIBBOGL} :
	${MAKE} -C $(dir $@) $(notdir $@)

LIBS	= $(LEFENCE) -lloadtrm $(_LIBFDISK)
LIBS_G	= $(LEFENCE) $(_LIBBOGL)    -lloadtrm $(_LIBFDISK)

_BUILDTIME := $(shell TZ=UTC date --utc "+%Y.%m.%d-%H:%M%z")

ifndef KERNEL_VERSION_CODE
KERNEL_VERSION_CODE := $(shell echo $$((2 * 65536 + 2 * 256)))
endif

CPPFLAGS  += -DBUILDTIME='"$(_BUILDTIME)"'
CPPFLAGS  += -DARCH='"$(architecture)"' -DARCHNAME='"$(architecture)"'
CPPFLAGS  += -DKERNEL_VERSION_CODE=${KERNEL_VERSION_CODE}
CPPFLAGS  += -DKVER='"${KVER}"'
ifdef FONT
 CPPFLAGS += -DFONT='"$(FONT)"'
endif

SOURCES          := $(wildcard *.c)


UTF_LIBS_BASE   = ../bf-utf
CPPFLAGS_LC     = -DUSE_LANGUAGE_CHOOSER
OBJECTS_LC      = $(OBJECTS:%.o=%.lc.o) langs.o
LIBS_LC = $(UTF_LIBS_BASE)/newt/libnewt.a $(UTF_LIBS_BASE)/slang/src/objs/libslang.a

LIBS_NLC         = -lslang -lnewt
OBJECTS		 = $(SOURCES:%.c=%.o)
OBJECTS_G	 = $(filter-out boxes.o, $(OBJECTS))

$(PROG) : $(LIBS)
$(PROG) : _OBJECTS = $(OBJECTS) $(OBJECTS_2)
$(PROG)	: $(OBJECTS) $(OBJECTS_2) $(_LIBFDISK)

$(PROG_LC) : $(LIBS) $(LIBS_LC) $(OBJECTS_LC)

$(PROG_G) : _LIBS    = $(LIBS_G)
$(PROG_G) : _OBJECTS = $(OBJECTS_G)
$(PROG_G) : $(_LIBBOGL) $(OBJECTS_G) $(_LIBFDISK)

$(PROG) $(PROG_G) :
	$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(OBJECTS) $(LIBS) $(LIBS_NLC)
	$(STRIP) $@

$(PROG_LC) :
	$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(OBJECTS_LC) $(LIBS) $(LIBS_LC)
	$(STRIP) $@
	$(MAKE) -C po all-utf


ifeq (${no_pointerize},)
__SOURCES = ${SOURCES}
endif

# These dependancies must be declared here so that 'make --jobs=4' can be used.
po/C.po  : po/dbootstrap.pot po/genc.awk
po/%.mo  : po/%.po
po/%.trm : po/%.mo

po/dbootstrap.pot po/C.po po/%.mo po/%.trm : ${__SOURCES}
	$(MAKE) -C po $(notdir $@)

langs.o: langs/langs.o
	cp $< $@

langs/langs.o :
	$(MAKE) DEBUG="$(DEBUG)" LINGUA="$(LINGUA)"		\
		CPPFLAGS="$(CPPFLAGS) $(CPPFLAGS_LC)" CFLAGS="$(CFLAGS)"	\
		-C langs $(notdir $@)

lang.h : po/C.mo
	gen-header $<

$(OBJECTS) : %.o : .translated/%.c

# Make sure this dir exists right now, as the Makefile is read, before
# targets that need it get run.  Used for .translated/ and .depend/
___ := $(shell [ -d .translated ] || mkdir .translated)

ifeq (${no_pointerize},)
__Cmo = po/C.mo
endif

.translated/%.c : %.c ${__Cmo} lang.h
	echo "#line 1 \"$<\"" > $@
	pointerize -m po/C.mo < $< >> $@

_all_tests = $(_TESTS) $(_TESTS_G) $(PROG)_test $(PROG_G)_test
$(_all_tests) %.test.o : override DEBUG   = true

$(_all_tests) %.test.o : override LINGUA  = $(TESTLANG)
$(_all_tests) %.test.o :          CFLAGS  = -Wall -g3 $(EXTRA_CFLAGS)
$(_all_tests) %.test.o :          LDFLAGS =

$(_TESTS) $(PROG)_test : _obj  = $(OBJECTS)
$(_TESTS) $(PROG)_test : _LIBS = $(LIBS)
$(_TESTS) $(PROG)_test : $(_LIBFDISK)
$(_TESTS) : %_test     : .translated/%.c $(OBJECTS) test.trm

$(_TESTS_G) $(PROG_G)_test : _obj  = $(OBJECTS_G)
$(_TESTS_G) $(PROG_G)_test : _LIBS = $(LIBS_G)
$(_TESTS_G) $(PROG_G)_test : $(_LIBBOGL) $(_LIBFDISK)
$(_TESTS_G) : %_g_test     : .translated/%.c $(OBJECTS_G) test.trm

$(PROG)_test $(PROG_G)_test : CPPFLAGS += -D_EXETESTING_

$(PROG_G)_test : $(OBJECTS_G) test.trm
$(PROG)_test   : $(OBJECTS) test.trm

$(PROG)_test $(PROG_G)_test : $(_obj)
	$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(_obj) $(_LIBS) $(LIBS_NLC)

%_test %_g_test :
	rm -f main.o
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -D_TESTING_ -o main.o .translated/main.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -D_TESTING_ -o $*.test.o .translated/$*.c
	$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $*.test.o $(filter-out $*.o,$(_obj)) $(_LIBS) $(LIBS_NLC)

%_lc_test:
	rm -f main.o
	$(CC) -c $(CPPFLAGS) $(CPPFLAGS_LC) $(CFLAGS) -D_TESTING_ -o main.o .translated/main.c
	$(CC) -c $(CPPFLAGS) $(CPPFLAGS_LC) $(CFLAGS) -D_TESTING_ -o $*.test.o .translated/$*.c
	$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $*.test.o $(filter-out $*.o,$(_obj)) $(_LIBS) $(LIBS_LC)


test.trm: po/$(TESTLANG).po
	$(MAKE) -C po $(TESTLANG).trm
	cp po/$(TESTLANG).trm test.trm 

%.test.o : CPPFLAGS += -D_TESTING_

# Must disable the builtin pattern rule so that building from the
# .translated/%.c works the way it should.
#
%.o : %.c

%.test.o %.o : .translated/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

%.lc.o : .translated/%.c
	$(CC) -c $(CPPFLAGS) $(CPPFLAGS_LC) $(CFLAGS) -o $@ $<

$(UTF_LIBS_BASE)/newt/libnewt.a:
	cd $(UTF_LIBS_BASE)/newt; CFLAGS=-Os ./configure
	$(MAKE) -C $(UTF_LIBS_BASE)/newt

$(UTF_LIBS_BASE)/slang/src/objs/libslang.a:
	cd $(UTF_LIBS_BASE)/slang; CFLAGS=-Os ./configure
	$(MAKE) -C $(UTF_LIBS_BASE)/slang

.PHONY : clean
clean :
	$(MAKE) -C po clean
	$(MAKE) -C langs clean
	rm -rf targetdir_test
	rm -f $(PROG) $(PROG_G) $(PROG_LC) *.o *_test
	rm -rf .translated

.PHONY : distclean
distclean : clean
	$(MAKE) -C po maintainer-clean
	$(MAKE) -C langs distclean
	rm -rf .depend
	rm -f lang.h test.trm C.mo kbddefault.h
	rm -f .tmp.*		# legacy translated files

# The Makefile, because of the include statement below, depends on all
# of the .depend/% files.  Each .depend/% will have the same set of
# dependancies as each corresponding %.o.  When you run a `make', the
# .depend/% will be rebuilt if the %.c file or anything it depends on
# has been modified.
#
# This rule will generate, for each %.c, a .depend/% that defines
# build dependancies for each corresponding %.o, %.test.o, and
# .depend/%.
#
# See: `info make', "Automatic Prerequisites", which is where I got
# the starting recipe for doing this. - karlheg 2000.02.11
#
___ := $(shell [ -d .depend ] || mkdir .depend)

.depend/% : %.c
	set -e;					\
	  touch -a lang.h;			\
	  echo ".depend/$(notdir $@) : $<" > $@; \
	  echo >> $@;				\
	  $(CC) -MM $(CPPFLAGS) $*.c |		\
	    sed -e 's,\($*\)\.o[ :]*,\1.o \1.test.o : ,g' | \
	    sed -e 's,\($*\.c\),.translated/\1,' >> $@; \
	  touch -m $@;

-include $(addprefix .depend/,$(SOURCES:%.c=%))

=== utilities/libfdisk/Makefile ===
KVER =
LIBS = -lc #-lefence

CC = gcc

CFLAGS = -Wall -Os -fomit-frame-pointer -fno-builtin
# CFLAGS = -Wall -O2 -fomit-frame-pointer

# CFLAGS = -Wall -O2
# CPPFLAGS = -DARCH="i386"

# CFLAGS = -Wall -O2
# CPPFLAGS = -DARCH="m68k"

ifeq ($(DEBUG),true)
CFLAGS += -g3
CPPFLAGS += -DDEBUG
endif

ifneq ($(findstring 2.0.,$(KVER)),)
CPPFLAGS += -DOLDKERNEL
endif

# PROGS = testing
PROGS =

OBJS = fdisk.o partbl_msdos.o partbl_osf.o partbl_sun.o partbl_amiga.o \
       partbl_atari.o partbl_mac.o partbl_acorn.o

HEADERS = fdisk.h byteorder.h config.h
SOURCES = $(OBJS:%.o=%.c) testing.c

all: libfdisk.a $(PROGS)

libfdisk.a: $(OBJS)
	$(AR) rcs $@ $(OBJS)

testing: testing.o libfdisk.a
	$(CC) $(LDFLAGS) -o testing $^ $(LIBS)

depend:	$(SOURCES:%.c=.depend/%)

clean: 
	rm -f $(OBJS) libfdisk.a testing.o

distclean: clean
	rm -f $(PROGS)
	rm -rf .depend

__deB-ORG := $(shell if [ -f .depend ];		\
		     then			\
			rm .depend;		\
		     elif [ ! -d .depend ];	\
		     then			\
			 mkdir .depend;		\
		     fi)

.depend/% : %.c
	set -e;					\
	  echo $@ : $< > $@;			\
	  echo >> $@;				\
	  $(CC) -MM $(CPPFLAGS) $*.c >> $@;	\
	  touch -m $@;

include $(SOURCES:%.c=.depend/%)

=== utilities/lowmemrd/Makefile ===
KVER =
OBJECTS = linuxrc.o mkswap.o fdisk.o llseek.o
LIBS = ../libfdisk/libfdisk.a /usr/lib/libz.a

CFLAGS = -O2 -Wall -s
ifneq ($(findstring 2.0.,$(KVER)),)
CFLAGS += -DOLDKERNEL
endif

all: linuxrc

linuxrc: $(OBJECTS) $(LIBS)
	$(CC) $(CFLAGS) -static -Wall -o linuxrc $(OBJECTS) $(LIBS)

clean:
	rm -f *.o 

distclean: clean
	rm -f linuxrc zcat

=== utilities/writemaps/Makefile ===
ifndef DATADIR
DATADIR = /usr/share/keymaps
endif

ifndef BINDIR
BINDIR = /usr/bin
endif

PROGS   = loadkeys 

WARN	= -Wall
DEFS	= -DDATADIR=\"$(DATADIR)\"
CFLAGS  = -O2
LDFLAGS = -s

CC	= gcc
YACC	= bison -y
LEX	= flex -8

default:	$(PROGS)

.c.o:
	$(CC) -c $(WARN) $(CFLAGS) $(DEFS) $<

all: $(PROGS)

# loadkeys.o: separate rule since the flex output does not permit -Wall
loadkeys.o:	loadkeys.c analyze.c
	$(CC) -c $(CFLAGS) $(DEFS) $<


distclean clean:
	rm -f core *.o analyze.c loadkeys.c loadkeys

$(PROGS): %: %.o

loadkeys: ksyms.o findfile.o getfd.o

ksyms.o: cyrillic.syms.h ethiopic.syms.h

loadkeys.o: paths.h

=== debian/changelog ===
boot-floppies (2.2.26) stable; urgency=low
  
  * Ethan Benson:
    - Fix powerpc bootloader installation to simply display a rtfm dialog
      if its run on a NewWorld, it can't install yaboot in potato.
    - Fix powerpc bootloader installation to setup /target/etc/quik.conf
      correctly.
    - Add dialog to the end of quik installation informing the user they
      have to fix OpenFirmware themselves and thier machine still won't
      actually boot yet.
  * Tommi Vainikainen: Finnish documentation updates
  * rebuild for new Potato post r3 updates

 -- Adam Di Carlo <aph@debian.org>  Tue, 12 Jun 2001 18:55:51 -0500
  

boot-floppies (2.2.25) stable; urgency=low

  * bump i386 to kernel 2.2.19
  * Chris Tillman: PowerMac documentation additions
  * Ethan Benson: PowerMac documentation corrections
  * Marcin Owsiany: fixed a typo in Polish docs (thanks to Micha Matysiak)
  * Phil Blundell:
    - include ne2k-pci driver on ARM systems
    - correct arm specifics in release.sh
  * David Whedon: DOS/Windows, Atari and MacOS floppy disk creation now
    seen by all archs

 -- Adam Di Carlo <aph@debian.org>  Thu,  7 Jun 2001 01:20:52 -0500

boot-floppies (2.2.24) stable; urgency=low

  * Phil Blundell: ARM fixes for the following:
    - NetWinder kernel is now "Image" not "vmlinuz"
    - 2.2.19 "tulip" driver breaks on NetWinder; use "old_tulip" instead
    - build NetWinder TFTP image
    - correct name of RiscPC keymap
    - documentation updates
  * Fabian Wauthier: German rescue disk translation updates
  * Chris Tillman: documentation corrections
  * Marcin Owsiany: added Polish dselect-beginner translation contributed by
    Pawe Tcza <pawel.tecza@poland.com>

 -- Adam Di Carlo <aph@debian.org>  Fri, 11 May 2001 00:57:02 -0400

boot-floppies (2.2.23) stable; urgency=low

  * Matt Kraai:
    - fix the drive_blocks array for hdg, hdh, hdi, and hdj
      (closes: Bug#90967)
  * Daniel Jacobowitz:
    - bump PowerPC to kernel 2.2.19.
    - fix URLs for bootx/bootvars
    - use \( \) in Makefile find invocation
    - bootprep.sh: Turn on CONFIG_IP_PNP_ENABLE also
  * Phil Blundell:
    - bump ARM kernel to 2.2.19

 -- Adam Di Carlo <aph@debian.org>  Sat, 14 Apr 2001 20:02:35 -0400

boot-floppies (2.2.22) stable; urgency=low

  * use 2.2.19pre17 kernels/modules on i386
  * documentation: talk about 'hda=noautotune' required on PowerMacs
    sometimes
  * i386 syslinux.cfg: pass through the disksize and flavor arguments to
    the other types of install methods, i.e., initrd, ramdisk*, floppy*;
    otherwise, it wouldn't know it's flavor and would try to use
    the wrong images
      -- THIS WAS A RATHER BAD BUG which affected CD and floppy installs
         on i386
  * rootdisk: fix building of i386 i18n images by bumping up inodes
  * dbootstrap: if we're i18n mode, write an entry 'LANGUAGE' in
    /root/dbootstrap_settings

 -- Adam Di Carlo <aph@debian.org>  Tue, 27 Mar 2001 01:46:35 -0600

boot-floppies (2.2.21) stable; urgency=low

  * Michael Sobolev
    - language chooser allows a default language
    - some Russian dbootstrap message updates
    - README-Translators: improvements
  * Paul Romanchenko: Russian dbootstrap updates and fixes
  * Marcin Owsiany <porridge@pandora.info.bielsko.pl>
    - Polish documentation updates
    - some language chooser build problems fixed
    - README-Translators: improvements
  * Peter Karlsson: Swedish dbootstrap updates
  * Erik Andersen <andersen@lineo.com>: Busybox fixes for loop device
    (closes: Bug#64500)
  * Karl Hammar: syslinux documentation for working around a loop when
    downloading SCSI scripts on NCR-based HBAs
  * Ethan Benson: PowerPC documentation improvements (closes: Bug#69161)
  * Adam Di Carlo:
    - sparc: bump kernel to 2.2.19pre11
    - alpha: bump kernel to 2.2.19pre13
    - Makefile: fix the localfiles rule, which was breaking in some
      instances; fix mirror-to-master rule in documentation/Makefile
    - Maintainers: credit Bill Bennet, The ComputerHelperGuy, for his
      donation of CD sets
    - documentation: fix alpha driver files (closes: Bug#78521); remove
      some stale stuff left over from slink, esp in the dbootstrap info;
      fix bad external links and some bad internal links 
      (closes: Bug#82024); update downloadable files based on newest
      released boot-floppies; talk about mounting stuff manually and other
      improvements (closes: Bug#69786); remove slink'isms from Chapter 7,
      adding a pretty much whole new discussion of the base-config steps;
      discuss install extra modules from floppy; update copyright notice;
      document booting from different CDs for different flavors on i386;
      discussion of Solaris/*BSD slices next to fdisk/cfdisk 
      (closes: Bug#65903); more stuff required in replacement rescue kernels
    - include French Release Notes
    - dbootstrap: minor message changes so things are more understandable;
      when we ask for the Debian CD-ROM, ask specifically for the *first*
      CD-ROM; ask fewer questions about archive locations, in fact, no
      questionsin the cases that some is using a media where things are
      where we can find them (closes: Bug#82912) the "load modules from
      floppy" step was reworded a bit to make it more clear that this an
      extra, non-std thing; fix some gratuitous references to floppies in
      the welcome message
    - release notes: fix a bad link on i386 to ports
    - README-Users.m4 (top-level README): fix alpha subarch reference;
      mention that local copies of stuff should retain the directory
      structure; improve discussion of various files; spell fixes
    - README-{flavors} (i386): put as README.txt in <flavor> dirs as
      well; refer users to the top-level README.txt for information on
      what the files are for
    - termwrap won't fail miserably if /etc/environment doesn't exist
      (closes: Bug#81319)
    - rootdisk: add /dev/ida/c[01]d[0123] devices back, which were


=== debian/control ===
Source: boot-floppies
Section: devel
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Standards-Version: 3.1.1
Build-Depends-Indep: debhelper
Build-Depends: glibc-pic, slang1-pic, libnewt-dev, libpopt-dev, zlib1g-dev, recode, gettext, m4, debiandoc-sgml, libi18n-langtags-perl, man-db, libpaperg, tetex-bin, tetex-extra, perl5, libwww-perl, pointerize, libgd1g-dev, bison, ash, dpkg-awk, flex, file, rsync, debhelper, gawk, cslatex, cspsfonts

Package: boot-floppies
Architecture: all
Depends: dpkg-dev, gcc, glibc-pic, slang1-pic, libnewt-dev, libpopt-dev, zlib1g-dev, recode, make, gettext, m4, debiandoc-sgml, libi18n-langtags-perl, man-db, libpaperg, tetex-bin, tetex-extra, perl5, libwww-perl, pointerize, libgd1g-dev, bison, ash, dpkg-awk, flex, file, rsync, debhelper, gawk, cslatex, cspsfonts
Suggests: python-xml
Description: Scripts to create the Debian installation floppy set.
 This package allows you to create a Debian installation system on floppy
 disk or other media, for bootstrapping Debian onto a new system. Most users
 will simply download the disk images to do this, and this package will
 generally only be used by advanced Debian maintainers.

=== debian/rules ===
#!/usr/bin/make -f
# derived from: Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# the debian-boot team

package	:= boot-floppies

prefix	:= debian/tmp
docdir	:= $(prefix)/usr/share/doc/$(package)
install_file	:= install -o root -g root -m 644 -p
install_script	:= install -o root -g root -m 755 -p
install_program	:= install -o root -g root -m 755 -p --strip
make_dir	:= install -d -o root -g root -m 755

arch	:= $(shell dpkg --print-architecture)
version	:= $(shell LC_ALL=C dpkg-parsechangelog | sed -n 's/^Version: *//p')
dist	:= $(shell LC_ALL=C dpkg-parsechangelog | sed -n 's/^Distribution: *//p')


build:
	$(checkdir)
	$(MAKE) localfiles
	$(MAKE) check
	$(MAKE) release
	touch build

release/bf-archive-install.sh:	debian/bf-archive-install.sh
	sed 's/%arch%/$(arch)/g; s/%dist%/$(dist)/g; s/%version%/$(version)/g;' $^ > $@
	chmod a+x $@

clean:
	$(checkdir)
	-$(MAKE) -i distclean
	dh_clean
	rm -f build
	find . -name '.#*' | xargs rm -f

binary-indep:	checkroot
	$(checkdir)
	dh_clean -k

	$(make_dir) $(prefix)/usr/src/$(package)
	tar --exclude $(prefix) --exclude CVS --exclude .cvsignore -cf - . \
	    | tar -C $(prefix)/usr/src/$(package) -xf -
	cd $(prefix)/usr/src/$(package) && ./debian/rules clean
	chown -R root.root $(prefix)/usr/src/$(package)
	chmod -R go-w,a+X,a-s $(prefix)/usr/src/$(package)
	cd $(prefix)/usr/src && \
	    GZIP=-9 tar -czf $(package).tar.gz --remove-files $(package)
	rm -rf $(prefix)/usr/src/$(package)

	dh_installdocs -i README
	dh_installchangelogs -i
	dh_compress -i
	dh_fixperms -i

	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch:	checkroot build
	$(checkdir)
	(cd release/ ; for i in * ; do \
		cp -p $$i ../../ ; \
		dpkg-distaddfile -f../debian/files $$i byhand - ; \
	done ) 

define checkdir
	test -f rootdisk.sh -a -f debian/rules
endef

# Below here is fairly generic really

binary:		binary-indep binary-arch

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
